"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class GraphProperties {
    constructor() {
        this.unmangledToMangledPropKeys = new Map();
    }
    add(mangledPropertyKey, unmangledPropertyKey) {
        this.unmangledToMangledPropKeys.set(unmangledPropertyKey, mangledPropertyKey);
    }
    getMangledProperty(unmangledProperty) {
        return this.unmangledToMangledPropKeys.get(unmangledProperty);
    }
    getMangledProperties() {
        return Array.from(this.unmangledToMangledPropKeys.values());
    }
}
exports.default = GraphProperties;
//# sourceMappingURL=GraphProperties.js.map