"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CircularDependenciesDetector = void 0;
const VisitedNodes_1 = require("./VisitedNodes");
class CircularDependenciesDetector {
    constructor(graphName) {
        this.graphName = graphName;
        this.visitedNodes = new VisitedNodes_1.VisitedNodes();
    }
    visit(graphName, dependencyName) {
        return this.visitedNodes.visit(graphName, dependencyName);
    }
    hasCircularDependencies() {
        return this.visitedNodes.isCircularPath();
    }
    getDependencies() {
        return this.visitedNodes.getNodes();
    }
    get firstDependencyName() {
        return this.visitedNodes.getNodes()[0];
    }
    clear() {
        this.visitedNodes.clear();
    }
}
exports.CircularDependenciesDetector = CircularDependenciesDetector;
//# sourceMappingURL=CircularDependenciesDetector.js.map