"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObtainLifecycleBoundGraphException = void 0;
const isDev_1 = require("../../utils/isDev");
class ObtainLifecycleBoundGraphException extends Error {
    constructor(graph) {
        super(ObtainLifecycleBoundGraphException.createMessage(graph));
    }
    static createMessage(graph) {
        const graphName = (0, isDev_1.isDev)() ? ` ${graph.name}` : '';
        return `Tried to obtain a @LifecycleBound graph${graphName}, but it was not created yet. `
            + '@LifecycleBound graphs can only be obtained after they were created by a React component or hook.';
    }
}
exports.ObtainLifecycleBoundGraphException = ObtainLifecycleBoundGraphException;
//# sourceMappingURL=ObtainLifecycleBoundGraphException.js.map