"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const reflect_1 = require("../../utils/reflect");
class PropsInjector {
    constructor(graph) {
        this.graph = graph;
    }
    inject(passedProps) {
        // eslint-disable-next-line prefer-object-spread
        return new Proxy(Object.assign({}, passedProps), {
            get: (target, p, receiver) => {
                return p in target ? reflect_1.Reflect.get(target, p, receiver) : this.graph.retrieve(p, receiver);
            },
        });
    }
}
exports.default = PropsInjector;
//# sourceMappingURL=PropsInjector.js.map