"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Model = void 0;
const useColdObservers_1 = require("../observable/cold/useColdObservers");
const Observable_1 = require("../observable/Observable");
class Model {
    use() {
        const observables = {};
        Object.getOwnPropertyNames(this).forEach((propertyName) => {
            const property = this[propertyName];
            if (property instanceof Observable_1.Observable) {
                observables[propertyName] = property;
            }
        });
        return (0, useColdObservers_1.useColdObservables)(observables);
    }
}
exports.Model = Model;
//# sourceMappingURL=Model.js.map