"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useObserver = useObserver;
/* eslint-disable no-param-reassign */
const react_1 = require("react");
const Observable_1 = require("./Observable");
function useObserver(observableOrGenerator) {
    const observable = (0, react_1.useMemo)(() => getOrGenerateObservable(observableOrGenerator), []);
    const [value, setValue] = (0, react_1.useState)(observable.value);
    const onNext = (0, react_1.useCallback)((next) => {
        observable.value = next;
    }, [observable]);
    (0, react_1.useEffect)(() => {
        return observable.subscribe(setValue);
    }, [observable]);
    return [value, onNext];
}
function getOrGenerateObservable(observableOrGenerator) {
    return observableOrGenerator instanceof Observable_1.Observable ? observableOrGenerator : observableOrGenerator();
}
//# sourceMappingURL=useObserver.js.map