"use strict";
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const src_1 = require("../../src");
const injectedValues_1 = __importDefault(require("./injectedValues"));
const StringProvider_1 = __importDefault(require("./StringProvider"));
let Subgraph = (() => {
    let _classDecorators = [(0, src_1.Graph)()];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = src_1.ObjectGraph;
    let _instanceExtraInitializers = [];
    let _stringProvider_decorators;
    let _stringFromSubgraph_decorators;
    let _unusedDependency_decorators;
    let _instanceId_decorators;
    var Subgraph = _classThis = class extends _classSuper {
        stringProvider() {
            return new StringProvider_1.default();
        }
        stringFromSubgraph() {
            return injectedValues_1.default.fromSubgraph;
        }
        unusedDependency() {
            throw Error('This dependency should not have been resolved since it is not required by anyone.');
        }
        instanceId() {
            return (0, lodash_1.uniqueId)('graph');
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _instanceExtraInitializers);
        }
    };
    __setFunctionName(_classThis, "Subgraph");
    (() => {
        var _a;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_a = _classSuper[Symbol.metadata]) !== null && _a !== void 0 ? _a : null) : void 0;
        _stringProvider_decorators = [(0, src_1.Provides)()];
        _stringFromSubgraph_decorators = [(0, src_1.Provides)()];
        _unusedDependency_decorators = [(0, src_1.Provides)()];
        _instanceId_decorators = [(0, src_1.Provides)()];
        __esDecorate(_classThis, null, _stringProvider_decorators, { kind: "method", name: "stringProvider", static: false, private: false, access: { has: obj => "stringProvider" in obj, get: obj => obj.stringProvider }, metadata: _metadata }, null, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _stringFromSubgraph_decorators, { kind: "method", name: "stringFromSubgraph", static: false, private: false, access: { has: obj => "stringFromSubgraph" in obj, get: obj => obj.stringFromSubgraph }, metadata: _metadata }, null, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _unusedDependency_decorators, { kind: "method", name: "unusedDependency", static: false, private: false, access: { has: obj => "unusedDependency" in obj, get: obj => obj.unusedDependency }, metadata: _metadata }, null, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _instanceId_decorators, { kind: "method", name: "instanceId", static: false, private: false, access: { has: obj => "instanceId" in obj, get: obj => obj.instanceId }, metadata: _metadata }, null, _instanceExtraInitializers);
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        Subgraph = _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return Subgraph = _classThis;
})();
exports.default = Subgraph;
//# sourceMappingURL=Subgraph.js.map